package treeplus.ui;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.geom.Rectangle2D;
import java.io.File;
import java.util.Map;

import javax.swing.AbstractAction;
import javax.swing.DefaultComboBoxModel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JScrollPane;
import javax.swing.JToolBar;
import javax.swing.JViewport;
import javax.swing.SwingConstants;

import org.jgraph.JGraph;
import org.jgraph.graph.CellView;
import org.jgraph.graph.DefaultEdge;
import org.jgraph.graph.DefaultGraphCell;
import org.jgraph.graph.DefaultGraphModel;
import org.jgraph.graph.DefaultPort;
import org.jgraph.graph.GraphModel;

import com.jgraph.layout.JGraphFacade;
import com.jgraph.layout.JGraphLayout;
import com.jgraph.layout.orthogonal.OrthogonalLinkRouter;
import com.jgraph.layout.tree.JGraphCompactTreeLayout;
import com.jgraph.layout.tree.JGraphTreeLayout;


import treeplus.tree.BFS;
import treeplus.tree.TreePlusGraph;
import treeplus.util.GraphLoader;


class FileAction extends AbstractAction {
	FileAction(String name){
		super(name);
		
	}

	public void actionPerformed(ActionEvent arg0) {
		// TODO Auto-generated method stub
		
	}
	
}

public class MainWindow extends JFrame {
	
	// private FileAction openAction
	JLabel statusbar = new JLabel("          Ihre Auswahl wird hier angezeigt." , JLabel.RIGHT);
	
	//statusbar.setFont( new Font("Serif", Font.BOLD, 30) );
	//statusbar.setVerticalAlignment(JLabel.TOP);
	// JLabel icon = new JLabel()
	
	DefaultGraphCell[] cells;
	
	JButton open = new JButton("open");
	
	// set in constructor!
	JGraph graph;
	// set in constructor!
	DefaultGraphModel model;
	
	TreePlusGraph graphTree;
	
	// UI
	JToolBar toolBar;
	JComboBox rootChooser;
	

	public MainWindow  (final JGraph graph, DefaultGraphModel model) {
		super();
		this.setTitle("TreePlus");
		this.graph = graph;
		this.model = model;
		// Add an Editor Panel
//		frame.getContentPane().add(new GraphEd());
	

		// Set Default Size and Position
		this.setSize(1000, 700);
		this.setLocationByPlatform(true);
		
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		// Set Menu Bar
		JMenuBar menuBar = new JMenuBar();
		
		// Create File Menu
		JMenu fileMenu = new JMenu("File");
		
		// Create Action Menu
		//JMenu elementMenu = new JMenu("Action");
		
		// Create select Root Menu in Action
		JMenu rootMenu = new JMenu("select Root");
		
		// Create Shortcuts
		fileMenu.setMnemonic('F');
		//elementMenu.setMnemonic('A');
		
		JMenuItem fileVerzeichnis1 = new JMenuItem("Open");
		
		// final JFileChooser fc = new JFileChooser();
		JFileChooser chooser = new JFileChooser();
	    
		fileVerzeichnis1.addActionListener(new Open());
		
		JMenuItem fileVerzeichnis2 = new JMenuItem("Close");
		
		//elementMenu.add(rootMenu);
		
		fileMenu.add(fileVerzeichnis1);
		fileMenu.add(fileVerzeichnis2);
		
		// close Action
		ActionListener al_close = new ActionListener() {
	        public void actionPerformed( ActionEvent e ) {
	        	System.exit( 0 );
	        }
	      };
	      fileVerzeichnis2.addActionListener( al_close );
		
		// Create Action
		// Object openAction = new Object();
		// TreePlusGraph graphTree = GraphLoader.loadGraph(file);
		// treeplus.tree.TreePlusGraph graphTree = treeplus.util.GraphLoader.loadGraph("text.txt");
		// File pull down Menu
		// addMenuItem(fileMenu, openAction);
		
		this.getContentPane().setLayout(new BorderLayout());
		
		// Add the Menus
		menuBar.add(fileMenu);
		//menuBar.add(elementMenu);
		menuBar.add(statusbar);
		this.getContentPane().add(graph);
		
		this.getContentPane().add(new JMenuBar());
		this.setJMenuBar(menuBar);
		
		// this.getContentPane().add(new JMenu("File"));
		
		// Build ComboBox
		rootChooser = new JComboBox();
		rootChooser.addItemListener(new ChooseRoot());
		
		// Add Toolbar
		toolBar = new JToolBar();
		toolBar.add(rootChooser);
		
		// Add Zoom in Function
		ImageIcon in = new ImageIcon("zoomin.gif");
	    JButton button2 = new JButton(in);
	    toolBar.add(button2);
	    
	    ActionListener al_in = new ActionListener() {
	        public void actionPerformed( ActionEvent e ) {
	        	graph.setScale(graph.getScale()*1.2);
	        }
	      };
	      button2.addActionListener( al_in );
	      
	      // Add Zoom out Function
	      ImageIcon out = new ImageIcon("zoomout.gif");
		  JButton button3 = new JButton(out);
		  toolBar.add(button3);
		    
		  ActionListener al_out = new ActionListener() {
		     public void actionPerformed( ActionEvent f ) {
		        graph.setScale(graph.getScale()/1.2);
		     }
		   };
		   button3.addActionListener( al_out );
		   
		   // Add Fit in Place Button
		   ImageIcon fit = new ImageIcon("hg.gif");
		   JButton button4 = new JButton(fit);
		   toolBar.add(button4);
			    
		   ActionListener al_fit = new ActionListener() {
			   public void actionPerformed( ActionEvent f ) {
				   //graph.repaint();
				   fitTreeToPage();
			   }
		   };
		   button4.addActionListener( al_fit );
		   
		   // Add Clear Function
		   ImageIcon clear = new ImageIcon("clear.gif");
		   JButton button5 = new JButton(clear);
		   toolBar.add(button5);
			    
		   ActionListener al_clear = new ActionListener() {
			   public void actionPerformed( ActionEvent f ) {
				 
				   graph.getGraphLayoutCache().remove(cells);
				  
			   }
		   };
		   button5.addActionListener( al_clear );
		   
	      
		this.getContentPane().add(toolBar, BorderLayout.NORTH);
		
		
		// Set Graph
		this.getContentPane().add(new JScrollPane(graph));
		
		// Add Open Gif
		//this.action(Action.SMALL_ICON, new ImageIcon("open.gif"));
		
		// Show Frame
		this.setVisible(true);
		
	}
	
	/**
	 * 
	 * @author Patschi
	 */
	
	
	public void fitTreeToPage() { 
		
		Rectangle2D p = graph.getCellBounds(graph.getRoots()); 
		if (p != null) { 
		if (graph.getParent() instanceof JViewport) { 
		JViewport viewPort = (JViewport) graph.getParent(); 
		Dimension s = viewPort.getExtentSize(); 
		
		double vScale = (double) s.getWidth() / (p.getX() + p.getWidth()); 
		double hScale = (double) s.getHeight() / (p.getY() + p.getHeight());                     
		double scale = Math.min(vScale, hScale); 

		scale = Math.max(Math.min(scale, 16), .01); 
		graph.setScale(scale);
		} 
	}
}

	class ChooseRoot implements ItemListener
    {		
		public void itemStateChanged(ItemEvent ie) {
			
			if (ie.getStateChange() != ItemEvent.SELECTED) {return;}
			String root = ie.getItem().toString();
			Object[] rootsrem = new Object[]{};
			graph.getGraphLayoutCache().removeCells(cells);
			model = new DefaultGraphModel();
			// CellView[] views = graph.getGraphLayoutCache().getCellViews();
			System.out.println("New ROOT: " +root);
			int rootIndx = graphTree.getIndexFromName(root);
			cells = BFS.buildTree(graphTree, rootIndx, rootsrem);
			// graph.getGraphLayoutCache().update(views);
			// graph.repaint();
			
			graph.setModel(model);
			graph.getGraphLayoutCache().insert(cells);
			

			Object[] roots = new Object[]{cells[rootIndx]}; // replace getRoots with your own
//			Object array of the cell tree roots. NOTE: these are the root cell(s) of
//			the tree(s), not the roots of the graph model.
			JGraphFacade facade = new JGraphFacade(graph, roots); // Pass the facade the JGraph instance

			JGraphCompactTreeLayout layout = new JGraphCompactTreeLayout(); // Create an instance of the appropriate layout			
			layout.setOrientation(SwingConstants.WEST);
			layout.setNodeDistance(10);
			layout.setLevelDistance(200);
			layout.setRouteTreeEdges(true);
			layout.setPositionMultipleTrees(true);
			
			layout.run(facade); // Run the layout on the facade.
			Map nested = facade.createNestedMap(true, true); // Obtain a map of the resulting attribute changes from the facade
			graph.getGraphLayoutCache().edit(nested); // Apply the results to the actual graph	
			
//			OrthogonalLinkRouter layout2 = new OrthogonalLinkRouter(); // Create an instance of the appropriate layout
//			layout2.run(facade); // Run the layout on the facade.
//			
//			nested = facade.createNestedMap(true, true); // Obtain a map of the resulting attribute changes from the facade
//			graph.getGraphLayoutCache().edit(nested); // Apply the results to the actual graph
						
			System.out.println("Num Roots: " +model.getRootCount());
			
		}
    }
	
	
	// Button Open clicked
	class Open implements ActionListener
    {
      public void actionPerformed(ActionEvent ae)
      {
        JFileChooser chooser = new JFileChooser();
        chooser.setMultiSelectionEnabled(true);
        int option = chooser.showOpenDialog(MainWindow.this);
  
        if(option == JFileChooser.APPROVE_OPTION)
        {
          File sf = chooser.getSelectedFile();
          String filelist = "nothing";
          
          if(sf.canRead())
          filelist = sf.getName();
  
          statusbar.setText("          Sie haben " + filelist + " gewhlt.");
          graphTree = GraphLoader.loadGraph(sf);
          cells = BFS.buildTree(graphTree, 0, new Object[]{});
          //------ rootChooser JList befuellen
          DefaultComboBoxModel heidi = new DefaultComboBoxModel();
          
          for (int i = 0; i < cells.length; i++) {
        	  if (!(cells[i] instanceof DefaultPort) && !(cells[i] instanceof DefaultEdge) && cells[i] != null) {
        		  heidi.addElement(cells[i].toString());
        		  System.out.println("model " +cells[i].toString());
        	  }
          }
          rootChooser.setModel(heidi);
          //------
          // graph.getGraphLayoutCache().insert(cells);
        }
        else
       {
          statusbar.setText("          Sie haben abgebrochen.");
        }
      } 
    }
	
}

