package treeplus.util;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.StringTokenizer;

import treeplus.tree.TreePlusGraph;

public class GraphLoader {

	
	public static TreePlusGraph loadGraph(File file) {
		BufferedReader reader = null;
		try {
			reader = new BufferedReader(new InputStreamReader(new FileInputStream(file)));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			return null;
		}
		
		ArrayList names = new ArrayList();
		int[][] graph = null;
		
		String curLine;
		try {
			// Read Names
			curLine = reader.readLine();
			StringTokenizer tok = new StringTokenizer(curLine, ",");
			System.out.println("--- Begin names ---");
			while (tok.hasMoreTokens()) {
				String curName = tok.nextToken(); 
				names.add(curName);
				System.out.println(curName);
			}
			System.out.println("--- End names ---");
			
			int size = names.size();
			graph = new int[size][size];
			
			// Read Matrix
			for (int i = 0; i < size; i++) {
				curLine = reader.readLine();
				tok = new StringTokenizer(curLine, " ");
				for (int j = 0; tok.hasMoreTokens(); j++) {
					graph[i][j] = Integer.parseInt(tok.nextToken()); 
				}
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		return new TreePlusGraph(graph, names);	
	}
	
}
